package kcg.faics.susa.service.impl;

import java.util.HashMap;
import java.util.List;

import kcg.faics.susa.vo.SearchVO;
import kcg.faics.susa.vo.SusaVO;

import org.springframework.stereotype.Repository;

import egovframework.rte.psl.dataaccess.EgovAbstractMapper;

/**
 * 외사수사 Mapper.
 * 
 * @author kimnomin
 *
 */
@Repository("susaMapper")
public class SusaMapper extends EgovAbstractMapper {

	/**
	 * 외사수사 정보를 반환한다.
	 * 
	 * @param susaVO
	 *            외사수사 VO
	 * @return 외사수사 VO
	 * @throws Exception
	 *             기본 예외 처리
	 */
	public SusaVO select(final SusaVO susaVO) throws Exception {
		return selectOne("Susa.select", susaVO);
	}

	/**
	 * 페이징 처리 없이 외사수사 목록 전체 목록을 반환한다.
	 * 
	 * @param searchVO
	 *            검색정보 객체
	 * @return 외사수사 목록
	 * @throws Exception 기본 예외 처리
	 */
	public List<SusaVO> selectListAll(final SearchVO searchVO) throws Exception {
		return selectList("Susa.selectListAll", searchVO);
	}

	/**
	 * 외사수사 목록를 반환한다.
	 * 
	 * @param searchVO
	 *            검색, 페이지정보 객체
	 * @return 외사수사 목록
	 * @throws Exception
	 *             기본 예외 처리
	 */
	public List<SusaVO> selectList(final SearchVO searchVO) throws Exception {
		return selectList("Susa.selectList", searchVO);
	}

	/**
	 * 외사수사 목록 개수를 반환한다.
	 * 
	 * @param searchVO
	 *            검색, 페이지정보 객체
	 * @return 외사수사 목록 개수
	 * @throws Exception
	 *             기본 예외 처리
	 */
	public int selectListCnt(final SearchVO searchVO) throws Exception {
		return (Integer) selectOne("Susa.selectListCnt", searchVO);
	}

	/**
	 * 외사수사정보 총 개수를 반환한다.
	 * 
	 * @param searchVO
	 *            검색, 페이지정보 객체
	 * @return 외사수사정보 총 개수
	 * @throws Exception
	 *             기본 예외 처리
	 */
	public int selectTotalCnt(final SearchVO searchVO) throws Exception {
		return (Integer) selectOne("Susa.selectTotalCnt", searchVO);
	}

	/**
	 * 외사수사 정보를 입력한다.
	 * 
	 * @param susaVO
	 *            외사수사 VO
	 * @return 맵 객체 {result: 성공여부, idx: 입력된 레코드의 key 값}
	 * @throws Exception
	 *             기본 예외 처리
	 */
	public HashMap<String, Object> insert(final SusaVO susaVO) throws Exception {
		HashMap<String, Object> map = new HashMap<String, Object>();

		int result = 0;
		try {
			result = insert("Susa.insert", susaVO);

			map.put("result", result);
			map.put("idx", susaVO.getIdx());
		} catch (Exception e) {
			e.printStackTrace();
		}
		return map;
	}

	/**
	 * 외사수사 정보를 갱신한다.
	 * 
	 * @param susaVO
	 *            외사수사 VO
	 * @return 성공 - 1, 실패 - 0
	 * @throws Exception
	 *             기본 예외 처리
	 */
	public int update(final SusaVO susaVO) throws Exception {
		return update("Susa.update", susaVO);
	}

	/**
	 * 외사수사 정보를 삭제한다.
	 * 
	 * @param susaVO
	 *            외사수사 VO
	 * @return 성공 - 1, 실패 - 0
	 * @throws Exception
	 *             기본 예외 처리
	 */
	public int delete(final SusaVO susaVO) throws Exception {
		return delete("Susa.delete", susaVO);
	}
}
